#!/usr/bin/env python

import math
import socket
import sys
import thread
import time

glbl = []

if len(sys.argv) < 5 or (not int(sys.argv[2]) or not int(sys.argv[3])):
	print "Usage: prog <host> <nthreads> <nconnections> <port> [ <port> ... }"
	sys.exit(1)

host = sys.argv[1]
nthreads = int(sys.argv[2])
ncons = int(sys.argv[3])
ports = []

for i in sys.argv[4:]:
	try:
		if type(i) == type(1) or int(i):
			ports.append(int(i))
		else:
			ports.append(int('a'))
	except ValueError:
		ports.append(socket.getservbyname(i, 'tcp'))

nports = len(ports)

def flooddest(host, port, cnt, lck, finlck, n):

	lck.acquire()

	try:
		tot = 0.0
		totsq = 0.0
		min = -1
		max = -1
		con = 0
		ref = 0

		rhost = socket.gethostbyname(host)

		for i in range(0, cnt):
			sys.stdout.write("%03d " % n)
			sys.stdout.flush()
			try:
				s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
				res = 's'

				start = time.time()

				s.connect(rhost, port)

				while res:
					res = s.recv(1024)
				end = time.time()

				diff = end - start

				tot = tot + diff
				totsq = totsq + diff * diff
				if min == -1 or diff < min:
					min = diff
				if max == -1 or diff > max:
					max = diff

				con = con + 1
			except socket.error, val:
				print 'socket.error: ', val
				ref = ref + 1

			del s

		if con:
			adv = tot / con
		else:
			adv = -1

		glbl.append((tot, totsq, min, max, con, ref))
	finally:
		finlck.release()

lcks = []
finlcks = []

print nthreads
for i in range(0, nthreads):
	lck = thread.allocate_lock()
	finlck = thread.allocate_lock()
	lck.acquire()
	finlck.acquire()
	thread.start_new_thread(flooddest, (host, ports[i % nports ], ncons, lck, finlck, i))

	lcks.append(lck)
	finlcks.append(finlck)

for i in lcks:
	i.release()

for i in finlcks:
	i.acquire()

del lcks

tot = 0.0
totsq = 0.0
adv = 0
min = -1
max = -1
con = 0
ref = 0
for i in glbl:
	tot = tot + i[0]
	totsq = totsq + i[1]
	if min == -1 or i[2] < min:
		min = i[2]
	if max == -1 or i[3] > max:
		max = i[3]
	con = con + i[4]
	ref = ref + i[5]

adv = tot / con
stddev = math.sqrt(totsq / con - adv * adv)

print ""
print tot, adv, stddev, min, max, con, ref
